Download it now!
Bug 101716 - Promote formula to the Insert root menu
Summary: Promote formula to the Insert root menu
Status: RESOLVED WONTFIX
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Formula Editor (show other bugs)
Version:
(earliest affected)
5.1.5.2 release
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: needsUXEval
Depends on:
Blocks: Main-Menu
  Show dependency treegraph
 
Reported: 2016-08-25 02:30 UTC by Bernd Wechner
Modified: 2016-10-05 05:44 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Bernd Wechner 2016-08-25 02:30:56 UTC
Sure, I'm biased, but I'm tired of math being treated as an Object on the Insert menu. The Insert menu offers among other things Image, Chart, Text Box all without being filed under Object. 

Could please see Formula promoted to the same level in fact it should ideally be grouped near or with Text box as that's one of it closest relatives, being a kind of Formula box. 

A small change like this I suspect translates to a big change in uptake among technical writers! A feeling of respect for one of their day to day language needs.

The Formula editor rocks!
Comment 1 Buovjaga 2016-09-21 19:43:59 UTC
Giving this to the design team to mull over.

Bernd: it is great to hear you are enjoying the formula editor. If you would like to contribute to this pet module of yours, there are always some bug reports to analyze and certainly design problems to solve.
You are invited to join IRC to discuss further: https://wiki.documentfoundation.org/Website/IRC (QA and design channels)
Comment 2 V Stuart Foote 2016-09-21 21:43:09 UTC
Sorry, abusing the Formula editor by running the Math module as an OLE tool has been a common source of formatting annoyances.

Folks would have much better results if they were to compose their formulas in the Math module and then link or insert the the ODF Formula from file.

And with the Math modules new ability to consume MathML, it would make more sense to deemphasize OLE formula composition in favor of workflows using the Formula editor outside of the document composition.

The UI positioning Formula were it is under Insert -> Object -> Formula (or alternatively the OLE Object dialog) is the correct functional emphasis.  Sure you can insert an OLE Formula and trigger the Math module, but why?  Using OLE ODF Formula from file is much more reliable and gives you more control over composition and then placement into your document.

I'd say NO emphatically.
Comment 3 Bernd Wechner 2016-09-21 22:47:18 UTC
I'll see your emphatic no, with an emphatic yes and raise you. ;-).

With all due respect I am happy to leave it to the design team, but if it contributes to their consideration:

1) Implementation issues like OLE are reminiscent of a developer's perspective, not that of user experience or marketing. It is of no consequence to an end-user that math is some linked object and that apparently a chart, an image, a text box, a frame etc. all are not.

2) Math is emphatically not an object but an integral part of most technical documents every bit as much as a chart or image is and how the back-end is implemented is not of immediate relevance to menu hierarchy here. 

3) MathML support sounds nice BTW

To answer the question "Sure you can insert an OLE Formula and trigger the Math module, but why?"

Because your average user of such a product neither knows nor cares about this implementation detail (triggering the Math module), just wants a minimal hassle way of getting nicely formatted math into a document.
Comment 4 Yousuf Philips (jay) (retired) 2016-09-22 01:31:52 UTC
Unfortunately inserting forumlas into documents isnt done enough to warrant including in the main insert menu, especially when the menu is already over packed. If a user does insert formulas alot, then they should likely unhide the forumla button found in the standard toolbar.
Comment 5 Bernd Wechner 2016-09-22 01:52:11 UTC
With all due respect again, that is putting the cart before the horse. 

1) Do you have data on how much it's used or are you just expressing an opinion. Either is fine, but please be clear and not ambiguous as the two carry distinctly different merit or weight in a decision.

2) I hold the opinion that it's not used much too based simply on my perceived distribution of writers across the board - with business and literary uses more prolific than technical in my impression. But then technical writers (notably students who can't buy MadCap Flare) are often stuck with Microsoft's equation editor (not as good as LibreOffice's) or go the rather more tedious route of not so WYSIWYG LaTeX options ... (historically quite popular).

3) But that is the very point this suggestion makes! That it is perhaps not used as much as it would be, because it's hidden, because technical writers are not welcomed and encouraged to slip into Writer say to write their scientific papers. The aim of recognizing math as an integral part of a document not some extra "object" is indeed to popularise its use.

Note that LibreOffice with it's fair support and use of LaTeX and (apparently impending or already available) use of MathML which facilitate rapid typing and copy/pasting for elements put it leagues ahead of MS-Office IMHO. And that is why I even bother to make a case for it to stand as the tool of choice for technical writers. And one step is to embrace math as not some freaky not-often used thing, but an ordinary every day part of a document.

That said, unhiding the Formula button is a great tip, and Id go further, it should be unhidden by default. For reason touched on here (i.e. welcoming and popularising math in text - it is not a small market by any measure, if somewhat smaller than business and literary users).
Comment 6 V Stuart Foote 2016-09-22 02:41:45 UTC
Probably WONTFIX rather than a WFM, yet for a heavy Formula user--activating the Formula button on the Standard toolbar (and repositioning it if a preferred customization) seems the most that is needed.

My concern remains that using the Insert Formula to directly embed OLE is a horrible way to compose technical texts.

The resulting Formulas can not be managed in any sense and are strictly embedded objects within the ODF archive. Using the Math module and saving to discrete ODF Formula gives the author much greater control over their formula and the structure of the text.

Would also add that for those that prefer LaTex, the TexMaths extension provides a much better interface than the StartMath based Math module but rather than ODF Formula produces SVG or PNG rendering using simple one line LaTex markup or inline LaTex (bracketed with \begin \end--along with some management of formulas within an ODF Text, Presentation or Drawing archive.  Worth a look if your interest lies in that direction. [1,2]

=-ref-=
1. http://extensions.libreoffice.org/extension-center/texmaths-1
2. https://sourceforge.net/projects/texmaths/files/0.42/
Comment 7 Yousuf Philips (jay) (retired) 2016-09-22 05:54:48 UTC
(In reply to Bernd Wechner from comment #5)
> 1) Do you have data on how much it's used or are you just expressing an
> opinion. Either is fine, but please be clear and not ambiguous as the two
> carry distinctly different merit or weight in a decision.

Yes we have data on the usage. Like ~30% of users access it from the toolbar and > 60% access it from the menu, and < 10% of users assign a shortcut for it. If we compare how often users insert a formula to inserting an image in writer, it is 4%. If we compare how often a user opens the insert menu in calc to insert a formula to inserting a row, it is 0.06%.

> 2) I hold the opinion that it's not used much too based simply on my
> perceived distribution of writers across the board - with business and
> literary uses more prolific than technical in my impression. But then
> technical writers (notably students who can't buy MadCap Flare) are often
> stuck with Microsoft's equation editor (not as good as LibreOffice's) or go
> the rather more tedious route of not so WYSIWYG LaTeX options ...
> (historically quite popular).

Yes formulas have a limited scope of users when taking all word processor users. I personally havent used a formula in a document in my life, but have seen documents with them in it.

> 3) But that is the very point this suggestion makes! That it is perhaps not
> used as much as it would be, because it's hidden, because technical writers
> are not welcomed and encouraged to slip into Writer say to write their
> scientific papers. The aim of recognizing math as an integral part of a
> document not some extra "object" is indeed to popularise its use.

I wouldnt call it hidden because it is in a submenu of the insert menu, as inserting an image use to be Insert > Picture > From File. Writer is a general purpose word processor, so we cant promote technical writer features and demote general purpose features. I wouldnt have minded to include it in insert menu, but we have to put limits on how large menus can grow.

> Note that LibreOffice with it's fair support and use of LaTeX and
> (apparently impending or already available) use of MathML which facilitate
> rapid typing and copy/pasting for elements put it leagues ahead of MS-Office
> IMHO. And that is why I even bother to make a case for it to stand as the
> tool of choice for technical writers. And one step is to embrace math as not
> some freaky not-often used thing, but an ordinary every day part of a
> document.

Glad to hear that LibreOffice is better than MSO in this regards, but I dont believe formulas will ever become an every day part of a document.

> That said, unhiding the Formula button is a great tip, and Id go further, it
> should be unhidden by default. For reason touched on here (i.e. welcoming
> and popularising math in text - it is not a small market by any measure, if
> somewhat smaller than business and literary users).

It was popular enough as a feature that i added it as a hidden button and once available space is there, i have plans to unhide it. Hopefully that may happen in LibreOffice 5.3.
Comment 8 Bernd Wechner 2016-09-22 11:06:17 UTC
(In reply to Yousuf Philips (jay) from comment #7)
> Yes we have data on the usage. Like ~30% of users access it from the toolbar
> and > 60% access it from the menu, and < 10% of users assign a shortcut for
> it. If we compare how often users insert a formula to inserting an image in
> writer, it is 4%. If we compare how often a user opens the insert menu in
> calc to insert a formula to inserting a row, it is 0.06%.

Awesome! I'm very pleased to hear it. Is that collected from running instances of LibreOffice? I imagine but don't recall, clicking through a permission form for such. Am curious because voluntary introduces a bias albeit of unknown relevance, and I digress (simply because I want to see such usage data collection in software we produce here and there are a few technical and ethical issues the team has explored (no action yet).

> I wouldnt call it hidden because it is in a submenu of the insert menu, as
> inserting an image use to be Insert > Picture > From File. Writer is a
> general purpose word processor, so we cant promote technical writer features
> and demote general purpose features. I wouldnt have minded to include it in
> insert menu, but we have to put limits on how large menus can grow.

Oh, don't misunderstand my suggestion. It is not one (merely) of ergonomics, as these are easy fixed with Customization anyhow, nor is it personal (as I have indeed fixed the ergonomics to suit me with customization), but catalyzed by a  recent reinstall and hence reconfig, a desire to share a vision, that math is not distinctly different to images or text boxes say and yet is hidden under some sub category akin strange things like embedded spreadsheets or whatever else). It's a pitch for giving it equal standing to put it in new users faces when exploring, to make the product more explicitly inviting for technical writers.

> Glad to hear that LibreOffice is better than MSO in this regards, but I dont
> believe formulas will ever become an every day part of a document.

Well that depend son the field you work in. For many it is an every day part of documents, or perhaps more to the point would be if more clearly an ordinary thing in the hierarchy, and perhaps a little less glitchy - I use in-line math symbols at times (of course only when I can't easily replicate it with character styling - which happens for terms like {grave X}_n^2 to cut an abstract example) and horizontal alignment is tuning drama. That said it is kick-ass awesome that it's not harder or impossible and is in fact pretty fluid. 

> It was popular enough as a feature that i added it as a hidden button and
> once available space is there, i have plans to unhide it. Hopefully that may
> happen in LibreOffice 5.3.

Awesome. As I said, I'm mainly about putting it on a par with similar things in the UX space (disregarding the implementation details of embedding).


(In reply to V Stuart Foote from comment #6)
> Probably WONTFIX rather than a WFM, yet for a heavy Formula user--activating
> the Formula button on the Standard toolbar (and repositioning it if a
> preferred customization) seems the most that is needed.

As a curio, not an accusation I'm curious if your adjusting status in that regard reflects a decision of the design team. If so, very pleased at the rapid turnaround (kudos) and if not (or even if so) am curious what the decisions making process is that drives LibreOffice. An aside of course and happy for PM on it, or a link to info I can read.

> My concern remains that using the Insert Formula to directly embed OLE is a
> horrible way to compose technical texts.

With all due respect that's a question of personal preference. I have a different view and experience having written technical documents for decades, and have known plenty who share that experience and plenty who disagree ... even some who still prefer hand written and love tablets for that (though they don't publish like that) or swear by some other product ... 

> Would also add that for those that prefer LaTex, the TexMaths extension
> provides a much better interface than the StartMath based Math module but
> rather than ODF Formula produces SVG or PNG rendering using simple one line
> LaTex markup or inline LaTex (bracketed with \begin \end--along with some
> management of formulas within an ODF Text, Presentation or Drawing archive. 
> Worth a look if your interest lies in that direction. [1,2]

Interesting indeed. Hadn't seen TexMaths. Not immediately appealing on a first trial, but could come in hand if I really want to align on = in a block of related equations.

Given it's a WONTFIX (assuming that is a design team decision not a proposal awaiting such) I'll let it rest of course. But in closing will suggest that one of my visions is to see math as integrated a German. The analogy I find robust and speak to my personal experience. If I'm writing a text and citing German passages or providing German names or titles, I invariably have to stop and find how to enter the odd special char like ΓΌ perhaps but the world of software has literally come so far that I can dip into and out of it, or French or even Chinese with a little more effort and it's all seen and treated as part of the text. So too, math (in the vision). 

And my interest was spurred to file only because I felt LibreOffice has indeed come tantalizingly close to that. A tad glitchy still, but surprisingly little! Very pleasingly and surprisingly so. Kudos to the team behind it.
Comment 9 Yousuf Philips (jay) (retired) 2016-10-05 05:44:08 UTC
(In reply to Bernd Wechner from comment #8)
> Awesome! I'm very pleased to hear it. Is that collected from running
> instances of LibreOffice? I imagine but don't recall, clicking through a
> permission form for such. Am curious because voluntary introduces a bias
> albeit of unknown relevance, and I digress (simply because I want to see
> such usage data collection in software we produce here and there are a few
> technical and ethical issues the team has explored (no action yet).

The user metrics was collected in 2009 during OpenOffice.org 3.1 and we hope to collect similar data with libreoffice once the necessary pieces are in place, though there hasnt been much priority set on it.

https://blog.documentfoundation.org/blog/2015/02/24/tender-to-develop-and-incorporate-usability-metrics-collection-for-libreoffice-201502-02/